function love.load()
	gr = love.graphics
	mo = love.mouse
	ti = love.timer
	
	love_timer_sleep = ti.sleep -- in s (like >= 0.8.0)
	if love._version:find("^0%.[0-7]%.") then -- if version < 0.8.0
		love_timer_sleep = function(s) ti.sleep(s * 1000) end
	end
	
	min_dt = 1 / 60
	next_time = ti.getMicroTime()
	grass = gr.newImage("grass.png")

	screenX = gr.getWidth() / 2
	screenY = gr.getHeight() / 2
end

function love.draw()
	block_width = grass:getWidth()
	block_height = grass:getHeight()
	block_depth = block_height / 2
	
	for x = -20, 20 do
		for y = -20, 20 do
			gr.draw(grass, get_coord(x, y))
		end
	end
	
	local mx, my = mo.getPosition()
	local x, y = mouse_coord(mx, my)
	local gx, gy = get_coord(x, y)
	
	gr.setColor(0, 0, 0, 32)
	gr.polygon('fill', gx, gy - block_depth / 2, gx - block_width / 2, gy, gx, gy + block_depth / 2, gx + block_width / 2, gy)
	gr.setColor(255, 255, 255, 255)
	
	gr.line(screenX, 0, screenX, gr.getHeight())
	gr.line(0, screenY, gr.getWidth(), screenY)
	
	gr.print("Current FPS: "..tostring(ti.getFPS()), 10, 10)
	gr.print("Mouse: "..tostring(mx)..", "..tostring(my), 10, 30)
	gr.print("Mouse Grid: "..tostring(x)..", "..tostring(y), 10, 50)
	
	local cur_time = ti.getMicroTime()
	if next_time <= cur_time then
		next_time = cur_time
		return
	end
	love_timer_sleep(next_time - cur_time)
end

function get_coord(x, y)
	return screenX + ((x - y) * (block_width / 2)), screenY + ((-x - y) * (block_depth / 2))
end

function mouse_coord(mx, my)
	return round((mx - screenX) / block_width - (my - screenY) / block_depth), round(-(mx - screenX) / block_width - (my - screenY) / block_depth)
end

function love.update(dt)
	next_time = next_time + min_dt
end

function round(num, idp)
	local mult = 10 ^ (idp or 0)
	return math.floor(num * mult + 0.5) / mult
end